#include "regdef.h" // kishida koji for WDT
#include "tcpip.h"
void	set_ether_header(char*, char*, unsigned short);
void	set_arp_data(unsigned short, char*, unsigned int);
int	ether_write(char*, int, int);
void	ip_interval();
#ifdef LARGE
  #define MAX_TABLE	128
#else
  #define MAX_TABLE	12
#endif
struct mac_info	table[MAX_TABLE];
struct mac_info	mytable;
unsigned int	gw_ip;
extern unsigned int netmask;
extern volatile int time_over_arp;


int table_init(char *mac, int addr) {
	int	i;

	for(i = 0;i < MAX_TABLE;i++) table[i].pri = 0;
	mytable.ip = addr;
	mytable.pri = 1;
	gw_ip = 0;
	memcpy(mytable.mac, mac, 6);
	return 0;
}

int set_gateway(int addr) {
	if((mytable.ip & netmask) != (addr & netmask)) return -1;
	gw_ip = addr;
	return 0;
}

char* ref_mac(int ip) {
	int	i, j;

	for(i = 0;i < MAX_TABLE;i++) {
		TCNT = 0x5a00 ; // kishida koji for WDT
		if(ip == table[i].ip && table[i].pri != 0) {
			for(j = 0;j < MAX_TABLE;j++) {
				if(table[j].pri > table[i].pri && table[j].pri != 0) table[j].pri--;
			}
			table[i].pri = mytable.pri - 1;
			return table[i].mac;
		}
	}
	return 0;
}

char* arp_querymac(int ip) {
	char broadcast[] = {0xff,0xff,0xff,0xff,0xff,0xff};
	char zero[] = {0,0,0,0,0,0};
	char *mac;
	int  i;

	if((mac = ref_mac(ip)) != 0) return mac;
	set_ether_header(broadcast, mytable.mac, ARP_TYPE);
	set_arp_data(ARP_REQ, zero, ip);
	ether_flush(sizeof(arp_header));
	time_over_arp = 5000;
	i = 0;
	while(time_over_arp > 0 && (mac = ref_mac(ip)) == 0) {
		TCNT = 0x5a00 ; // kishida koji for WDT
		ip_interval();
		if(i++ > 1000000) return 0;
	}
	if(time_over_arp <= 0) return 0;
	return mac;
}

char* query_mac(int ipaddr) {
	int	ip;
	
	ip = ipaddr;
	if((mytable.ip & netmask) != (ip & netmask)) {
		if(gw_ip == 0) return 0;
		else ip = gw_ip;
	}
	return arp_querymac(ip);
}

int regist_mac(char *mac, int ip) {
	int	i, n;
	char	*mac2;

	mac2 = ref_mac(ip);
	if(mac2 != 0) {
		if(memcmp(mac2, mac, 6) == 0) return 0;
		for(i = 0;i < MAX_TABLE;i++) {
			if(table[i].ip == ip) {
				memcpy(table[i].mac, mac, 6);
				return 1;
			}
		}
	}
	if(ref_mac(ip) != 0) return 0;
	for(i = 0;i < MAX_TABLE;i++) {
		if(table[i].pri == 0) {
			table[i].ip = ip;
			memcpy(table[i].mac, mac, 6);
			table[i].pri = mytable.pri++;
			break;
		}
	}
	/* fix by kishida koji (2009/12/5) */
//	if(i == 12) {
//		for(i = 0;i < 12;i++) {
	if(i == MAX_TABLE) {
		for(i = 0;i < MAX_TABLE;i++) {
	/* fix end */
			if(table[i].pri == 1) {
				n = i;
				table[n].ip = ip;
				memcpy(table[n].mac, mac, 6);
				for(i = 0;i < 12;i++) table[i].pri--;
				table[n].pri = mytable.pri - 1;
				break;
			}
		}
	}
	return 1;
}

void set_arp_data(unsigned short operation, char *mac, unsigned int ip) {
	arp_header	header;
	char		*ptr;

	header.hard_type = 1;
	header.protocol_type = IP_TYPE;
	header.hard_size = 6;
	header.protocol_size = 4;
	header.operation = operation;
	memcpy(header.src_mac, mytable.mac, 6);
	memcpy(header.src_ip, (char*)(&mytable.ip), 4);
	memcpy(header.dest_mac, mac, 6);
	memcpy(header.dest_ip, (char*)(&ip), 4);
	ptr = (char*)(&header) + sizeof(ether_header);
	ether_write(ptr, sizeof(ether_header),
		    sizeof(arp_header) - sizeof(ether_header));
}

int arp() {
	unsigned int	src_ip, *p;
	arp_header	arp;

	ether_read((char*)&arp, 0, sizeof(arp_header));
	p = (int*)arp.src_ip; src_ip = *p;
	if((mytable.ip & netmask) != (src_ip & netmask)) return -1;
	if(arp.hard_type != 1) return -1;
	if(arp.protocol_type != IP_TYPE) return -1;
	if(arp.hard_size != 6) return -1;
	if(arp.protocol_size != 4) return -1;
	if(*((int*)arp.dest_ip) != mytable.ip) return -1;
	switch(arp.operation) {
	case ARP_REQ:
		set_ether_header(arp.src_mac, mytable.mac, ARP_TYPE);
		set_arp_data(ARP_ANS, arp.src_mac, src_ip);
		ether_flush(sizeof(arp_header));
		break;
	case ARP_ANS:
		regist_mac(arp.src_mac, src_ip);
		break;
	}
	return 0;
}

