/* H8/OSѥإåե ... by Yukio Mituiwa*/

#define ASCII	0
#define BINARY	1
#define SIO	2
#define LCD	4
#define PS2	4
#define MEM	6

#define IPADDR(a,b,c,d) (unsigned int)a*0x1000000+b*0x10000+c*0x100+d

#define AF_UNIX	1
#define AF_INET	2

#define SOCK_STREAM	0
#define SOCK_DGRAM	0x40

#define TCP_DATA	1
#define TCP_ACK		2
#define TCP_CLOSE	3
#define TCP_BEGIN	4

#define	EXP 0x20
#define	ACK 0x10
#define	PSH 0x08
#define	RST 0x04
#define	SYN 0x02
#define	FIN 0x01

struct sockaddr_in {
	unsigned char	sin_len;	/* ¤Τ礭 */
	unsigned char	sin_familly;	/* PF_INET */
	unsigned short	sin_port;	/* ݡֹ */
	unsigned int	sin_addr;	/* ɥ쥹   */
	unsigned int seq; /* ֹ */ // kishida koji for retry TCP packet
	unsigned int ack; /* ֹ */ // kishida koji for retry TCP packet
};

#define DeviceReset	0x08
#define DownloadMicrocode 0x92
#define DeviceDiagnostic  0x90
#define FlushCache	0xe7
#define IdentifyDevice	0xec
#define GetMediaStatus	0xda
#define ReadMultiple	0xc4
#define ReadSector	0x20
#define WriteMultiple	0xc5
#define WriteSector	0x30
#define SetMultiple	0xc6

#define DownEdge	1
#define UpEdge		2

#define	READ	1
#define	WRITE	2
#define	APPEND	4

#define	CS0	0x01
#define	CS1	0x02
#define	CS2	0x04
#define	CS3	0x08
#define	CS4	0x10
#define	CS5	0x20
#define	CS6	0x40
#define	CS7	0x80

#define	FILEREAD	1
#define	FILEWRITE	2
#define	FILEAPPEND	3
#define	PATHSIZ		13*10

#define	DIRENT_DIR	0x10

#define RTC_YEAR	8
#define RTC_MONTH	7
#define RTC_WEEK	6
#define RTC_DAY		5
#define RTC_HOUR	4
#define RTC_MINUTE	3
#define RTC_SECOND	2

typedef struct _diskinfo {
	unsigned int	root_dir_entry;
	unsigned int	media_sector;
	unsigned int	fat_sector_size;
	unsigned short	sector_size;
	unsigned short	reserve_sector;
	unsigned short	device_id;
	unsigned char	sector_per_clustor;
	unsigned char	fat_number;
	unsigned char	media_ident;
	unsigned char	fat;
} diskinfo;

typedef struct _dirent {
	unsigned int	fat;
	unsigned int	size;
	char		*path;
	diskinfo	*disk;
	unsigned short	max;
	unsigned short	index;
	unsigned char	attr;
} dirent;

extern int  *mem_size;

extern int (*sys_write)(char *, int);
extern int (*write_string)(char *);
//extern int (*write_mode)(int);  // kishida koji (2009.10.18)
extern int (*write_mode)();	// kishida koji (2009.10.18)
extern int (*set_membuf)(int, char*, int);
extern int (*read_mode)(int);
extern int (*sys_read)(char *, int);
extern int (*read_string)(char *, int);
extern int (*sio_speed)(int, int);
extern int (*atohex)(char *);
extern void (*lcd_clear)(void);
#define lcd_setup(l,c,r,b) lcdsetup((l << 8)+c,r,b)
extern void (*lcdsetup)(int, volatile char*, char*);
#define lcd_setupw(l,c,r,b) lcdsetupw((l << 8)+c,r,b)
extern void (*lcdsetupw)(int, volatile short*, short*);
extern int (*timer1_regist)(void (*)(), unsigned int);
extern int (*timer1_unregist)(void);
extern int (*timer2_regist)(void (*)(), unsigned int);
extern int (*timer2_unregist)(void);
extern int (*timer3_regist)(void (*)(), unsigned int);
extern int (*timer3_unregist)(void);
extern int (*sleep)(int);
extern int (*ether_write)(char*, int, int);
extern int (*ether_read)(char*, int, int);
extern int (*ether_flush)(int);
extern int (*ether_get)(void);
extern void (*ether_init)(int);
extern void (*ether_setup)(void);
extern int (*get_ether_status)(void);
extern char* (*get_mac_address)(void);
extern int (*ip_setup)(unsigned int, unsigned int);
extern char* (*query_mac)(unsigned int);
extern int (*write_decimal)(unsigned int);
extern int (*atodec)(char *);
extern int (*get_ipinfo)(unsigned int*, unsigned int*);
extern int (*ether_setmac)(char *);
extern int (*ether_getmac)(char *);
extern int (*udp_read)(char *, int);
extern int (*udp_write)(char *, int);
extern int (*udp_regport)(int (*)(unsigned short, struct sockaddr_in*));
extern int (*udp_unregport)(int (*)(unsigned short, struct sockaddr_in*));
extern void (*save_regport)(void);
extern void (*recover_regport)(void);
extern void (*set_udpaddr)(struct sockaddr_in *, unsigned short);
extern int (*tcpsocket)(int, int (*)(int, int, struct sockaddr_in*));
extern int (*tcp_regport)(int (*)(unsigned short, struct sockaddr_in*, unsigned char, int));
extern int (*tcp_unregport)(int (*)(unsigned short, struct sockaddr_in*, unsigned char, int));
extern void (*set_tcpaddr)(struct sockaddr_in *, unsigned short);
extern int (*tcp_read)(char*, int);
extern int (*tcp_write)(int, char*, int);
extern int (*tcp_status)(int);
extern int (*tcpclose)(int);
extern int (*ata_setup)(int, int);
extern int (*int_regist)(int, void (*)());
extern int (*int_unregist)(int);
extern int (*ata_sel_drive)(int);
extern int (*ata_reset)(void);
extern int (*non_data_command)(unsigned short, int, int);
extern int (*ata_identify)(short*);
extern int (*data_in_command)(unsigned short, char*, int, int);
extern int (*data_out_command)(unsigned short, char*, int, int);
extern int (*ata_driveinfo)(char*, int*);
extern int (*get_hddsize)(void);
extern int (*set_gateway)(unsigned int);
extern int (*ps2_setup)(volatile char*, char*);
extern int (*ps2_setupw)(volatile short*, short*);
extern int (*keyread)(char*);
extern void (*nmi_edge)(int);
extern int (*eep_setup)(volatile char*, volatile char*, char*);
extern int (*eep_setupw)(volatile short*, volatile short*, short*);
extern int (*eep_write)(int, char*, int);
extern int (*eep_read)(char*, int, int);
extern int (*dirent_init)(char*, dirent*);
extern int (*dirent_get)(dirent*);
extern int (*makedir)(char*);
extern int (*delete)(char*);
extern int (*openfile)(char*, int);
extern int (*readfile)(char*, int, int);
extern int (*writefile)(char*, int, int);
extern int (*renfile)(char*, char*);
extern int (*closefile)(int);
extern int (*get_file_size)(int);
extern int (*print)();
extern int (*sprint)();
extern int (*scan)();
extern int (*sscan)();
extern void (*bussize_setup)(int, int);
extern void (*cs_setup)(int);
extern int (*rtc_setup)(volatile char*, volatile char*, char*);
extern int (*rtc_setupw)(volatile short*, volatile short*, short*);
extern int (*format)(char*);
extern int (*rtc_write)(int, int);
extern int (*rtc_read)(int);
extern int (*sio_change)(int);
extern int (*easy_max)();
extern int (*easy_dir)(int, char*);
extern void (*easy_format)(char);
extern int (*easy_find)(char*);
extern int (*easy_del)(char*);
extern int (*easy_create)(char*, int);
extern int (*easy_write)(int, char*, int, int);
extern int (*easy_read)(int, char*, int, int);
extern int (*easy_exec)(int, char**, char*);
extern int (*get_eepsize)();
extern int (*putch)(int);
extern int (*getch)();
