#include "regdef.h"
extern int eepsize;

void reg_init() {
	volatile int	i;

#ifdef SH2_7050
	PGCR2 = 0xbee0;		/* SCI0-SCI2 are enable 0xbee0*/
	PACR = 0xffff;		/* A0-A15 are enable */
	PBCR = 0x0100;		/* A16 is enable */
	PCCR2 = 0x0441;		/* -CS2/-RD/-WRL are enable */
	PDCR = 0x00ff;		/* D0-D7 are enable */
	BCR1 = 0;		/* CS0-CS3 are 8 bit bus */
#endif
#ifdef SH2_7045
	BCR1 = 0x202f;		/* CS0/CS2/CS3 are 16bit-bus,CS is 32 bit */
	BCR2 = 0x5510;		/* wait 1 idle */
	WCR1 = 0x0002;		/* CS0 is 2 wait, CS1-3 are 0 wait */
	PACRH = 0x5020;		/* WRHH WRHL DRAK0 are enable */
	PACRL1 = 0x5550;	/* CK -RD -WRH -WRL -CS[1..0] are enable */
	PACRL2 = 0x2165;	/* -CS2 TXD1 RXD1 DREQ0 TXD0 RXD0 are enable */
	PBCR1 = 0x000a;		/* A21/A20 are enable */
	PBCR2 = 0xafff;		/* -RDWR -CASH -CASL -RAS A19/A18/A17/16 are enable */
	PCCR = 0xffff;		/* A15-0 are enable */
	PDCRH1 = 0x5555;	/* D31-24 are enable */
	PDCRH2 = 0x5555;	/* D23-16 are enable */
	PDCRL = 0xffff;		/* D15-0 are enable */	
	PECR1 = 0x0000;
	PECR2 = 0x0000;

	WCR2 = 0x000f;		/* default */
	DCR = 0x0021;		/* 8bit-bus 10bit-address */
	RTCSR = 0x001a;		/* clk x 2048 */
	RTCOR = 10;		/* 1.5[ms] reflesh cycle */
#endif
#ifdef H8_300H
	/* BUS  initialize */
	P1DDR = 0xff;	/* A0-7    is enable */
	P2DDR = 0xff;	/* A8-15   is enable */
	P5DDR = 0x01;	/* A16     is enable */
	P8DDR = 0x0e;	/* CS1-3 is enable */
#endif
#ifdef H8_3067
	/* DRAM initialize */
	RTCOR = 10;	/* 1.5[ms] reflesh cycle */
	RTMCSR = 0x30;	/* clk x 2048 */
	DRCRB = 0x90;
//	DRCRA = 0x3c;
	DRCRA = 0x35;		// EDO(BE) OFF   by kishida.koji (koji@windvane.info) 2008/9/23
//	PADR = 0x16 ;		// test by kishida
	for(i = 0;i < 400000;i++){
		TCNT = 0x5a00 ;  // for WDT by kishida koji (koji@windvane.info)
	};
#endif
}

int init() {
	int	reg;
	volatile int xx ;

//	PBDDR = 0xff ; // kishida
//	PBDR = 0xf0 ;
//	PADDR = 0xff ;
//	PADR = 0x01 ;
//	for( xx=0 ; xx < 10000 ;xx++) ;

/* kishida start */
	/* WDT */
	#define RSTCSR (*(volatile unsigned short *)0xffff8e)
	RSTCSR = 0xa500 ;
	TCSR = 0xa57E;
	TCNT = 0x5a00 ;
	//  set WDT by kishida koji (koji@windvane.info)
/* kishida end*/
	
	eepsize = 0;
#ifdef SHELL
	reg_init();
	eep_probe();
#endif
/* kishida start */
//	PADR = 0x04 ;
	TCNT = 0x5a00 ;
/* kishida end*/
	reg_init();
//	PADR = 0x05 ;
	int_init();
//	PADR = 0x06 ;
#ifdef SH2
	asm("	stc	sr,%0":"=r"(reg):);
	reg &= 0xffffff0f;
	asm("	ldc	%0,sr"::"r"(reg));
#else
//3068
	asm("andc.b\t#127,ccr");
//	PADR = 0x07 ;
#endif
/* kishida start */
	TCNT = 0x5a00 ;
/* kishida end*/
	sio_init();
//	PADR = 0x08 ;
#if defined (H8_300H) || defined(SH2)
//3068
	ne_init();
//	PADR = 0x09 ;
	ip_init();
//	PADR = 0x0A ;
	timer_init();
//	PADR = 0x0B ;
/* kishida start */
	TCNT = 0x5a00 ;
/* kishida end*/
#endif
//	ps2_init();  //  commet out by kishida koji (koji@windvane.info)
#ifdef WITH_FS
//3068
//	file_init();  //  commet out by kishida koji (koji@windvane.info)
#endif
}
